 ODAPI Configuration Utility

The Object Database Application Programming Interface (ODAPI) is the interface Paradox uses to access your data. ODAPI needs information about your specific environment in order to properly access and deliver your data. This information is stored in the ODAPI Configuration file. The ODAPI Configuration Utility lets you change the settings in this file. Note: Changes made with the ODAPI Configuration Utility won't take effect until you restart Paradox for Windows.

The default name of the ODAPI Configuration files is ODAPI.CFG. To use a different configuration file, use the Local Settings Utility (its icon is part of the Paradox for Windows program group).

Network Control File Directory

Enter the complete path of the PDOXUSRS.NET file. This path should be set to a subdirectory on your network that is accessible to every user who will share Paradox tables. Each user must set this path individually.

Any additional applications used to access Paradox tables on a network must also use the same network file specified here.

System Language Driver

Select the driver to use as a default if the Paradox and dBASE language drivers are undefined.

Paradox Language Driver

Determines the sort order, capitalization, and string comparison conventions that are specific to your country's language for Paradox tables. The default for users in the United States is the Paradox ASCII driver.

dBASE Language Driver

Determines the sort order, capitalization, and string comparison conventions that are specific to your country's language for dBASE tables.

Buffer Size (in Kilobytes)

Specify a range for the memory buffer size.

Minimum	specify the minimum amount of memory you want available. The minimum valid value for this is 32. The default is 256.

Maximum	specify the maximum amount of memory you want available. The maximum valid value for this is 65535. The default is 2048.

Local Share

Local Share is On	lets you safely share tables with non-ODAPI applications that you're running locally. If you select this option, make sure that SHARE.EXE is loaded before starting Paradox for Windows, or Paradox won't start.

Local Share is Off	turns off the data locks set by Local share. If you are sharing data with non-ODAPI applications, this leaves you unprotected from data corruption. This option may provide a slight performance increase in accessing local data. The default is Local Share is off.

Advanced

The Advanced button opens the ODAPI Full Tree Editor dialog box. The ODAPI Full Tree Editor dialog box lets advanced users change additional system settings.

Note: Make sure you set your Windows Control Panel settings to match any changes you make to ODAPI settings.

See also

Supported Paradox Language Drivers

Supported dBASE Language Drivers


 ODAPI Full Tree Editor

This information is intended for advanced users and application developers who use specialized data formats not normally used by Windows or Paradox.

The ODAPI Full Tree Editor dialog box lets you display and edit the settings ODAPI uses to configure itself, Paradox, and your data formats.

To use the Full Tree Editor, select the Catagory, Group, Section (when applicable), and Item you wish to display or edit. Enter any new settings in the Value text box.

The current setting for the Item will appear in the Value text box. The Help Text text box provides information for the setting you have selected.

By default, your ODAPI settings match the settings used in the country where you purchased Paradox and Windows. You should only change ODAPI's settings after configuring the International and Country settings in Windows Control Panel. After you do this, define ODAPI's settings to match those in Windows Control Panel; otherwise, queries that match values may produce unexpected results.

For information on each setting in the Full Tree Editor see Settings in the ODAPI Full Tree Editor.

Tip: If you accidentally change the wrong value, you can cancel the change by closing the ODAPI Full Tree Editor dialog box. Choose Cancel from the ODAPI Configuration Utility dialog box.

See also

Settings in the ODAPI Full Tree Editor


 Settings in the Odapi Full Tree Editor

SYSTEM

SYSTEM | INIT

SYSTEM | INIT | VERSION

SYSTEM | INIT | LOCAL SHARE

SYSTEM | INIT | MINBUFSIZE

SYSTEM | INIT | MAXBUFSIZE

SYSTEM | INIT | LANGDRIVER

SYSTEM | INIT | NET TYPE

SYSTEM | INIT | NET DIR

SYSTEM | INIT | MAXFILEHANDLES

SYSTEM | INIT | SYSFLAGS

SYSTEM | FORMATS

SYSTEM | FORMATS | DATE

SYSTEM | FORMATS | DATE | SEPARATOR

SYSTEM | FORMATS | DATE | MODE

SYSTEM | FORMATS | DATE | FOURDIGITYEAR

SYSTEM | FORMATS | DATE | YEARBIASED

SYSTEM | FORMATS | DATE | LEADINGZEROM

SYSTEM | FORMATS | DATE | LEADINGZEROD

SYSTEM | FORMATS | TIME

SYSTEM | FORMATS | TIME| TWELVEHOUR

SYSTEM | FORMATS | TIME | AMSTRING

SYSTEM | FORMATS | TIME | PMSTRING

SYSTEM | FORMATS | TIME | SECONDS

SYSTEM | FORMATS | TIME | MILSECONDS

SYSTEM | FORMATS | NUMBER

SYSTEM | FORMATS | NUMBER | DECIMALSEPARAT

SYSTEM | FORMATS | NUMBER | THOUSANDSEPAR

SYSTEM | FORMATS | NUMBER | LEADINGZERO

DRIVERS

DRIVERS | PARADOX

DRIVERS | PARADOX | INIT

DRIVERS | PARADOX | INIT | VERSION

DRIVERS | PARADOX | INIT | TYPE

DRIVERS | PARADOX | INIT | LANGDRIVER

DRIVERS | PARADOX | TABLE CREATE

DRIVERS | PARADOX | TABLE CREATE | LEVEL

DRIVERS | PARADOX | TABLE CREATE | BLOCK SIZE

DRIVERS | PARADOX | TABLE CREATE | FILL FACTOR

DRIVERS | PARADOX | TABLE CREATE | STRICTINTEGRTY

DRIVERS | DBASE

DRIVERS | DBASE | INIT

DRIVERS | DBASE | INIT | VERSION

DRIVERS | DBASE | INIT | TYPE

DRIVERS | DBASE | INIT | LANGDRIVER

DRIVERS | DBASE | TABLE CREATE

DRIVERS | DBASE | TABLE CREATE | LEVEL

DRIVERS | DBASE | TABLE CREATE | MDX BLOCK SIZE

DRIVERS | DBASE | TABLE CREATE | MEMO FILE BLOCK

DATABASES

DATABASES | TYPE

DATABASES | PATH


SYSTEM

SYSTEM defines the settings used to start Paradox and the formats used to internally convert character strings to date, time, and number values.


SYSTEM | INIT

SYSTEM | INIT contains the settings used to start Paradox and allocate your Windows resources, such as memory and network use.


SYSTEM | INIT | VERSION

SYSTEM | INIT | VERSION describes the version of ODAPI you're using. This is an internal setting and should not be changed.


SYSTEM | INIT | LOCAL SHARE

SYSTEM | INIT | LOCAL SHARE tells ODAPI to perform network-style file locking on a local drive. It is set to TRUE if Local Share is on and FALSE otherwise. The default is FALSE.


SYSTEM | INIT | MINBUFSIZE

SYSTEM | INIT | MINBUFSIZE is the minimum amount of memory (in KB) Paradox reserves for its database disk cache. The value can be any integer greater than 32 and less than the total amount of RAM available to Windows. The default is 256. Non-integer values are ignored.


SYSTEM | INIT | MAXBUFSIZE

SYSTEM | INIT | MAXBUFSIZE is the maximum amount of memory (in KB) Paradox will allocate for its database disk cache. The value can be any integer greater than the MINBUFSIZE and less than (or equal to) the total amount of RAM available to Windows. The default is 2048. Non-integer values are ignored.


SYSTEM | INIT | LANGDRIVER

SYSTEM | INIT | LANGDRIVER is the system language driver. Choose a valid Paradox language driver. The default is the OEM driver appropriate for your country's version of Windows, for example, ASCII for U.S. workstations.


SYSTEM | INIT | NET TYPE

SYSTEM | INIT | NET TYPE is the type of network you're using and can be one of four values: NOVELL, 3COM, BANYAN, or STARLAN. This setting is not used by Paradox for Windows in this release and is reserved for future use.


SYSTEM | INIT | NET DIR

SYSTEM | INIT | NET DIR is the directory containing your network control file (PDOXUSRS.NET). The default is blank. To change this setting, enter an existing directory path.


SYSTEM | INIT | MAXFILEHANDLES

SYSTEM | INIT | MAXFILEHANDLES is the maximum number of file handles ODAPI uses. The value can be any integer ranging from 5 to 256. Higher values improve performance but use more Windows resources. The default is 256.


SYSTEM | INIT | MAXFILEHANDLES
SYSTEM | INIT | SYSFLAGS

SYSTEM | INIT | SYSFLAGS is an internal setting used by ODAPI and should not be changed.

You can change the non-internal settings in this group from the ODAPI Configuration Utility dialog box.


SYSTEM | FORMATS

SYSTEM | FORMATS contains the settings used to convert string values into date, time, or number values and to convert these values to character strings. In Paradox, these settings are used when you change a field's type (during Restructure), run queries using selection criteria or pattern matching, and add (or subtract) tables.

Note: We do not recommend changing FORMAT settings unless you need to work with specialized data formats or customize the International settings of Windows Control Panel to values not normally used by your country. If you customize Windows Control Panel, we strongly recommend you make similar changes to your ODAPI FORMAT settings; otherwise queries using selection criteria and pattern matching may return unexpected results.


SYSTEM | FORMATS | DATE

SYSTEM | FORMATS | DATE configures the settings used to format date values.


SYSTEM | FORMATS | DATE | SEPARATOR

SYSTEM | FORMATS | DATE | SEPARATOR is the character used to separate the month, day, and year components of a date value. For example, the value "12/31/92" uses the forward-slash ( / ) as a separator. The default is the character normally used in the country selected in the Windows Control Panel when you install Paradox.


SYSTEM | FORMATS | DATE | MODE

SYSTEM | FORMATS | DATE | MODE controls the order of the month, day, and year components and can be 0 (for MDY), 1 (for DMY), or 2 (for YMD). Other values are ignored. The default is the order normally used in the country selected in the Windows Control Panel when you install Paradox.


SYSTEM | FORMATS | DATE | FOURDIGITYEAR

SYSTEM | FORMATS | DATE | FOURDIGITYEAR specifiies the number of digits for the year value (four or two). If TRUE, years are expressed in four digits (For example, 1993). If FALSE, the default, years have two digits (93).


SYSTEM | FORMATS | DATE | YEARBIASED

SYSTEM | FORMATS | DATE | YEARBIASED tells Paradox whether or not it should add 1900 to years entered as two digits. For example, if TRUE and you enter "7/21/69," Paradox interprets your value as "7/21/1969", otherwise, the date is interpreted as entered (in this case, "7/21/0069"). The default is TRUE.


SYSTEM | FORMATS | DATE | LEADINGZEROM

SYSTEM | FORMATS | DATE | LEADINGZEROM specifies whether or not single digit month values have a leading zero. For example, if you enter "1/1/80" and this is set to TRUE , Paradox interprets the date as "01/1/80." If FALSE, the value is "1/1/80." The default is TRUE.


SYSTEM | FORMATS | DATE | LEADINGZEROD

SYSTEM | FORMATS | DATE | LEADINGZEROD controls whether or not single digit day values have a leading zero. For example, if you enter "1/1/80" and this is set to TRUE, Paradox interprets the value as "1/01/80." If FALSE, your date is "1/1/80." The default is TRUE.


SYSTEM | FORMATS | TIME

SYSTEM | FORMATS | TIME contains the formats used for time values.


SYSTEM | FORMATS | TIME | TWELVEHOUR

SYSTEM | FORMATS | TIME | TWELVEHOUR tells Paradox whether or not time values are expressed using a twelve-hour clock. For example, if TRUE and it is currently 8:21 p.m., the time is "08:21 PM." If FALSE, the time is "20:21." The default is TRUE.


SYSTEM | FORMATS | TIME | AMSTRING

SYSTEM | FORMATS | TIME | AMSTRING is the string of characters used to indicate morning (before noon and after midnight) times, when TWELVEHOUR is TRUE. The setting can be any valid string of characters. The default is "AM". If TWELVEHOUR is FALSE, this item is ignored.


SYSTEM | FORMATS | TIME | PMSTRING

SYSTEM | FORMATS | TIME | PMSTRING is the string of characters used to indicate express evening (after noon and before midnight) times, when TWELVEHOUR is TRUE. The setting can be any valid string of characters. The default is "PM". If TWELVEHOUR is FALSE, this item is ignored.


SYSTEM | FORMATS | TIME | SECONDS

SYSTEM | FORMATS | TIME | SECONDS specifies whether or not time values include seconds. For example, if this setting is TRUE and it is currently 8:21:35 p.m., the time value is "8:21:35 PM." If FALSE, the time is "8:21 PM". The default is TRUE.


SYSTEM | FORMATS | TIME | MILSECONDS

SYSTEM | FORMATS | TIME | MILSECONDS specifies whether or not time values include milliseconds. If this setting is TRUE, time values include milliseconds (for example, "8:21:35:54 PM".) If FALSE, time values do not include milliseconds. The default is FALSE.


SYSTEM | FORMATS | NUMBER

SYSTEM | FORMATS | NUMBER contains the settings used to format numbers.


SYSTEM | FORMATS | NUMBER | DECIMALSEPARATOR
SYSTEM | FORMATS | NUMBER | DECIMALSEPARAT

SYSTEM | FORMATS | NUMBER | DECIMALSEPARAT is the character used to separate the decimal portion of a number from its integer portion. For example, in 3.14, a period ( . ) separates the decimal portion (14) from the integer (3). This can be any valid character and defaults to the standard decimal separator used in the country selected in the Windows Control Panel when you install Paradox.


SYSTEM | FORMATS | NUMBER | THOUSANDSEPARATOR
SYSTEM | FORMATS | NUMBER | THOUSANDSEPARAT

SYSTEM | FORMATS | NUMBER | THOUSANDSEPARAT is the character used to separate large numbers into their "thousands" components. For example, in 1,000,000.00, commas (,) separate the millions and thousands components. This can be any valid character and defaults to the standard thousands separator used in the country where you bought Paradox.


SYSTEM | FORMATS | NUMBER | LEADINGZERO

SYSTEM | FORMATS | NUMBER | LEADINGZERO indicates whether numbers between 1 and -1 have a leading zero to the left of the decimal. For example, if your value is .14 and this setting is TRUE, your value is 0.14. If FALSE, there is no leading zero (.14). The default is TRUE.


DRIVERS

The DRIVERS category determines how Paradox creates, sorts, and handles your tables.


DRIVERS | PARADOX

DRIVERS | PARADOX contains the settings used for Paradox tables.


DRIVERS | PARADOX | INIT

DRIVERS | PARADOX | INIT describes the initialization parameters used for Paradox tables (.DB).

Note: Because the INIT section contains internal settings, we do not recommend changing the values of its items, except as previously described.


DRIVERS | PARADOX | INIT | VERSION

DRIVERS | PARADOX | INIT | VERSION is the Borland-internal version number of your ODAPI Paradox driver. This is for internal use only; do not modify it.


DRIVERS | PARADOX | INIT | TYPE

DRIVERS | PARADOX | INIT | TYPE describes the type of Paradox driver being used by ODAPI. Currently, this can only be FILE. This is an internal setting; do not modify it.


DRIVERS | PARADOX | INIT | LANGDRIVER

DRIVERS | PARADOX | INIT | LANGDRIVER is the default language driver for Paradox tables. Choose the internal name of any Paradox language driver listed in the ODAPI language drivers; however, we recommend setting this item from the ODAPI Configuration Utility dialog box.

When changing language drivers in the ODAPI Full Tree Editor, you must enter the new driver's internal name. The Supported Paradox Language Drivers table shows both names for all language drivers used in this version of Paradox.

See also

Supported Paradox Language Drivers


DRIVERS | PARADOX | TABLE CREATE

DRIVERS | PARADOX | TABLE CREATE controls the settings of Paradox tables.


DRIVERS | PARADOX | TABLE CREATE | LEVEL

DRIVERS | PARADOX | TABLE CREATE | LEVEL is the table format used to create temporary Paradox tables and can be 4 for the Standard table format introduced in Paradox 4.0 or 3 for the Compatible table format used by Paradox 3.5 and earlier versions. The default is 4.

Note: To use BLOB fields, secondary indexes, and referential integrity, you must create a level-4 table.


DRIVERS | PARADOX | TABLE CREATE | BLOCK SIZE

DRIVERS | PARADOX | TABLE CREATE | BLOCK SIZE is the size of disk blocks used to store records. When you create a table, Paradox allocates disk space in blocks. This can be 1024, 2048, 3072, or 4096. The default is 2048.


DRIVERS | PARADOX | TABLE CREATE | FILL FACTOR

DRIVERS | PARADOX | TABLE CREATE | FILL FACTOR is a percentage value that determines when Paradox allocates another disk block for index files. When an index has filled this amount of the current disk block, Paradox allocates another disk block for the file. Smaller values offer better performance, but increase the size of your indexes. Larger values give smaller index files, but increase the time needed to create an index. The value can be any integer ranging from 1 to 100. The default is 95.


DRIVERS | PARADOX | TABLE CREATE | STRICTINTEGRY
DRIVERS | PARADOX | TABLE CREATE | STRICTINTEGRTY

DRIVERS | PARADOX | TABLE CREATE | STRICTINTEGRTY determines whether or not applications that do not support referential integrity (for example, Paradox 4.0) can modify tables using that feature. For example, if TRUE and you attempt to change a table with referential integrity in Paradox 4.0, you receive an error message. If FALSE, you can change the table, but you risk the integrity of your data. The default is TRUE.


DRIVERS | DBASE

DRIVERS | DBASE contains the settings used for dBASE tables.


DRIVERS | DBASE | INIT

DRIVERS | DBASE | INIT describes the initialization parameters used for dBASE tables (.DBF).

Note: Because the INIT section contains internal settings, we do not recommend changing the values of its items, except as previously described.


DRIVERS | DBASE | INIT | VERSION

DRIVERS | DBASE | INIT | VERSION is the Borland-internal version number of your ODAPI dBASE driver. This is for internal use only; do not modify it.


DRIVERS | DBASE | INIT | TYPE

DRIVERS | DBASE | INIT | TYPE describes the type of dBASE driver being used by ODAPI. Currently, this can only be FILE. This is an internal setting; do not modify it.


DRIVERS | DBASE | INIT | LANGDRIVER

DRIVERS | DBASE | INIT | LANGDRIVER is the current language driver for dBASE tables. You can choose the internal name of any dBASE language driver; however, we recommend setting this item from the ODAPI Configuration Utility dialog box.

When changing language drivers in the ODAPI Full Tree Editor, you must enter the new driver's internal name. The Supported dBASE Language Drivers table shows both names for all language drivers used in this version of Paradox.

See also

Supported dBASE Language Drivers


DRIVERS | DBASE | TABLE CREATE

DRIVERS | DBASE | TABLE CREATE controls the settings for new dBASE tables.


DRIVERS | DBASE | TABLE CREATE | LEVEL

DRIVERS | DBASE | TABLE CREATE | LEVEL is the table format used to create dBASE temporary tables and can be 4 for the dBASE IV table format or 3 for the table format used in dBASE III and dBASE III Plus. The default is 4.


DRIVERS | DBASE | TABLE CREATE | MDX BLOCK SIZE

DRIVERS | DBASE | TABLE CREATE | MDX BLOCK SIZE is the size of disk blocks (in bytes) Paradox allocates for .MDX files. The value can be any integer that is a multiple of 512. The default is 1024.


DRIVERS | DBASE | TABLE CREATE | MEMO FILE BLOCK

DRIVERS | DBASE | TABLE CREATE | MEMO FILE BLOCK is the size of disk blocks (in bytes) Paradox allocates for memo (.DBT) files. The value can be any integer that is a multiple of 512. The default is 1024.


DATABASE
DATABASES

This contains the directory aliases defined in Paradox and includes one group and section (DB INFO) for each alias. If you have not defined any aliases, there are no groups.


DATABASE | TYPE
DATABASES | TYPE

DATABASE | TYPE is the type of alias that has been defined. Currently, this can only be STANDARD.


DATABASE | PATH
DATABASES | PATH

DATABASE | PATH is the directory path the alias represents.

Note: You cannot create new aliases with the Full Tree Editor. To create aliases, use the Alias Manager dialog box. Choose File | Aliases from the Paradox for Windows Desktop.

Note: We do not recommend using the ODAPI Full Tree Editor dialog box to edit directory aliases. Instead, use the Alias Manager dialog box in Paradox.


ODAPI Language drivers

When changing language drivers in the ODAPI Full Tree Editor, you must enter the new driver's internal name, not the full name presented in the ODAPI Configuration Utility dialog box. The following table shows both names for all language drivers used in this version of Paradox. (The numbers in parenthesis show the OEM code page the driver is designed for.)


Supported Paradox Language Drivers

The following table shows the language drivers you can use for Paradox tables, along with the code page for each driver. Advanced users can enter the internal name in the ODAPI Full Tree Editor.

Driver name	Internal	Code Page

Paradox 'ascii'	ascii	437

Paradox 'intl'	intl	437

Paradox 'nordan'	nordan	865

Paradox 'nordan40'	nordan40	865

Paradox 'swedfin'	swedfin	437


Supported dBASE Language Drivers

The following table shows the language drivers you can use for dBASE tables. The number next to the driver indicates the code page for that driver. Advanced users can enter the internal name in the ODAPI Full Tree Editor. The language or country supported by each language driver is also shown.

Driver name	Internal	Country

Da dBASE 865	DB865DA0	Danish

De dBASE 865	DB865DE0	German

EnUK dBASE 473	DB437UK0	English (U.K)

EnUS dBASE 437	DB437US0	English (U.S.)

Es dBASE 437	DB437ES1	Spanish

Fi dBASE 437	DB437FI0	Finnish

Fr dBASE 437	DB437FR0	French

FrCA dBASE 850	DB850CF0	French (Canadian)

FrCA dBASE 863	DB863CF1	French (Canadian)

It dBASE 437	DB437IT0	Italian

NI dBASE 437	DB437NL0	Dutch

No dBASE 437	DB437NO0	Norwegian

Pt dBASE 850	DB850PT0	Portuguese (Brazilian)

Pt dBASE 860	DB860PT0	Portuguese

Sv dBASE 437	DB437SV0	Swedish